package com.adc.da.system.controller;


import com.adc.da.base.web.BaseController;
import com.adc.da.system.entity.CheckDetailObd;
import com.adc.da.system.service.ICheckDetailObdService;
import com.adc.da.util.http.ResponseMessage;
import com.adc.da.util.http.Result;
import io.swagger.annotations.ApiOperation;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

/**
 * <p>
 * OBD与OBD_DETAILS关联表 前端控制器
 * </p>
 *
 * @author jobob
 * @since 2021-04-08
 */
@RestController
@RequestMapping("/${restPath}/check-detail-obd")
public class CheckDetailObdController extends BaseController<CheckDetailObd> {

    @Autowired
    private ICheckDetailObdService iCheckDetailObdService;

    @ApiOperation(value = "保存认证核查参数")
    @PostMapping("/saveRealCheckParameter")
    public ResponseMessage saveRealCheckParameter(@RequestBody CheckDetailObd checkDetailObd) {
        List<String> codeList = new ArrayList<>();
        if (checkDetailObd != null && StringUtils.isBlank(checkDetailObd.getDetailId())) {
            checkDetailObd.setDetailId("");
        }
        if (checkDetailObd != null  && StringUtils.isNotBlank(checkDetailObd.getObdId())) {
            codeList = Arrays.asList(checkDetailObd.getDetailId().split(","));
        }
        iCheckDetailObdService.saveRealCheckParameter(codeList,checkDetailObd.getObdId());
        return Result.success();
    }
    @ApiOperation(value = "保存法规核查项关系")
    @GetMapping("/saveStandCheckParameter")
    public ResponseMessage saveStandCheckParameter(String mouldId,String detailId,String status) {

        if(StringUtils.isBlank(mouldId)||StringUtils.isBlank(detailId)||StringUtils.isBlank(status)){
            return Result.error();
        }
        return Result.success("200","保存成功",iCheckDetailObdService.saveStandCheckParameter(mouldId,detailId,status));

    }
}
