package com.adc.da.system.controller;


import com.adc.da.dto.reqDTO.CheckRealVehicleVerificationDto;
import com.adc.da.dto.resDTO.ModelServiceItemDTO;
import com.adc.da.system.entity.CheckModelSeriesList;
import com.adc.da.system.entity.CheckModelSeriesListResult;
import com.adc.da.system.entity.CheckRealVehicleVerification;
import com.adc.da.system.entity.CheckVehicleCheckMenu;
import com.adc.da.system.service.ICheckModelSeriesListResultService;
import com.adc.da.system.service.ICheckModelSeriesListService;
import com.adc.da.system.service.ICheckRealVehicleVerResultService;
import com.adc.da.system.service.ICheckRealVehicleVerificationService;
import com.adc.da.system.service.ICheckVehicleAndSeriesService;
import com.adc.da.system.service.ICheckVehicleCheckMenuService;
import com.adc.da.util.http.ResponseMessage;
import com.adc.da.util.http.Result;

import com.adc.da.util.utils.UserUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Date;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * 车型系列表控制器
 */
@RestController
@Api(value = "车型系列表接口")
@RequestMapping("/${restPath}/checkModelSeriesList")
public class CheckModelSeriesListController {
    /**
     * request
     */
    @Autowired
    private HttpServletRequest request;
    /**
     * 日志service
     */
//    @Autowired
//    private ICheckOperationLogService iCheckOperationLogService;
    /**
     * checkModelSeriesListService
     */
    @Autowired
    private ICheckModelSeriesListService checkModelSeriesListService;

    /**
     * checkVehicleAndSeriesService
     */
    @Autowired
    private ICheckVehicleAndSeriesService checkVehicleAndSeriesService;

    /**
     * checkEnterpriseDataDetailsService
     */
//    @Autowired
//    private ICheckEnterpriseDataDetailsService checkEnterpriseDataDetailsService;

    /**
     * checkEnterpriseDataService
     */
//    @Autowired
//    private ICheckEnterpriseDataService checkEnterpriseDataService;

    /**
     * cdVehiclesService
     */
//    @Autowired
//    @Lazy(value = true)
//    private ICdVehiclesService cdVehiclesService;

    /**
     * checkVehicleCheckMenuService
     */
    @Autowired
    private ICheckVehicleCheckMenuService checkVehicleCheckMenuService;

    /**
     * checkRealVehicleVerificationService
     */
    @Autowired
    private ICheckRealVehicleVerificationService checkRealVehicleVerificationService;

    @Autowired
    private ICheckModelSeriesListResultService checkModelSeriesListResultService;

    @Autowired
    private ICheckRealVehicleVerResultService checkRealVehicleVerResultService;

//    @Autowired
//    private ICheckStatuteService checkStatuteService;

    /**
     * 车型系列表分页查询
     *
     * @param checkModelSeriesList
     * @return
     */
    @ApiOperation(value = "|queryCheckModelSeriesListByPage|车型系列表分页查询")
    @GetMapping(value = "/queryCheckModelSeriesListByPage")
    public ResponseMessage queryCheckModelSeriesListByPage(CheckModelSeriesList checkModelSeriesList) {
        checkModelSeriesList.setBase(UserUtil.getQyId());
        Page page = new Page(checkModelSeriesList.getPage(), checkModelSeriesList.getPageSize());
        if (StringUtils.isNotEmpty(checkModelSeriesList.getVehicleType())) {
            checkModelSeriesList.setVehicleType(checkModelSeriesList.getVehicleType().toUpperCase());
        }
        IPage<CheckModelSeriesList> checkModelSeriesListIPage =
                checkModelSeriesListService.queryCheckModelSeriesListByPage(page, checkModelSeriesList);
        List<CheckModelSeriesList> data = checkModelSeriesListIPage.getRecords();
        ModelServiceItemDTO modelServiceItemDTO;
        String[] itemArr = new String[] {"认证一致性核查","关键件一致性核查","OBD静态验证","标准符合性核查","扫码符合性检查"};
        for (CheckModelSeriesList checkModelSeries : data) {
            List<ModelServiceItemDTO> itemData = new ArrayList<>();
            for (String itemStr : itemArr) {
                modelServiceItemDTO = new ModelServiceItemDTO();
                switch (itemStr){
                    case "认证一致性核查" :
                        modelServiceItemDTO.setCarOperator(itemStr);
                        modelServiceItemDTO.setOperationTime(checkModelSeries.getRealVehicleTime());
                        modelServiceItemDTO.setOperationUser(checkModelSeries.getRealMouldOperator());
                        modelServiceItemDTO.setType(checkModelSeries.getRealMouldStatus());
                        modelServiceItemDTO.setRemark(checkModelSeries.getCarRemarks());
                        break;
                    case "关键件一致性核查" :
                        modelServiceItemDTO = new ModelServiceItemDTO();
                        modelServiceItemDTO.setCarOperator(itemStr);
                        modelServiceItemDTO.setOperationTime(checkModelSeries.getKeyTime());
                        modelServiceItemDTO.setOperationUser(checkModelSeries.getKeyOperator());
                        modelServiceItemDTO.setType(checkModelSeries.getKeyStatus());
                        modelServiceItemDTO.setRemark(checkModelSeries.getKeyRemark());
                        break;
                    case "OBD静态验证" :
                        modelServiceItemDTO = new ModelServiceItemDTO();
                        modelServiceItemDTO.setCarOperator(itemStr);
                        modelServiceItemDTO.setOperationTime(checkModelSeries.getObdTime());
                        modelServiceItemDTO.setOperationUser(checkModelSeries.getObdOperator());
                        modelServiceItemDTO.setType(checkModelSeries.getObdStatus());
                        modelServiceItemDTO.setRemark(checkModelSeries.getObdRemark());
                        break;
                    case "扫码符合性检查" :
                        modelServiceItemDTO = new ModelServiceItemDTO();
                        modelServiceItemDTO.setCarOperator(itemStr);
                        modelServiceItemDTO.setOperationTime(checkModelSeries.getScanCodeTime());
                        modelServiceItemDTO.setOperationUser(checkModelSeries.getScanCodeOperator());
                        modelServiceItemDTO.setType(checkModelSeries.getScanCodeStatus());
                        modelServiceItemDTO.setRemark(checkModelSeries.getScanCodeRemark());
                        break;
                    case "标准符合性核查" :
                        modelServiceItemDTO = new ModelServiceItemDTO();
                        modelServiceItemDTO.setCarOperator(itemStr);
                        modelServiceItemDTO.setOperationTime(checkModelSeries.getStandTime());
                        modelServiceItemDTO.setOperationUser(checkModelSeries.getStandOperator());
                        modelServiceItemDTO.setType(checkModelSeries.getStandStatus());
                        modelServiceItemDTO.setRemark(checkModelSeries.getStandRemark());
                        break;
                    default:
                        break;
                }
                itemData.add(modelServiceItemDTO);
            }
            checkModelSeries.setArr(itemData);
        }
        checkModelSeriesListIPage.setRecords(data);
        return Result.success("200", "车型系列表分页查询", checkModelSeriesListIPage);
    }

    /**
     * 车型系列结果分页查询
     *
     * @param checkModelSeriesList
     * @return
     */
    @ApiOperation(value = "|queryCheckModelSeriesListByPage|车型系结果列表分页查询")
    @GetMapping(value = "/querySuccessCheckModelSeriesList")
    public ResponseMessage querySuccessCheckModelSeriesList(CheckModelSeriesList checkModelSeriesList) {
        checkModelSeriesList.setBase(UserUtil.getQyId());
        Page page = new Page(checkModelSeriesList.getPage(), checkModelSeriesList.getPageSize());
        if (StringUtils.isNotEmpty(checkModelSeriesList.getVehicleType())) {
            checkModelSeriesList.setVehicleType(checkModelSeriesList.getVehicleType().toUpperCase());
        }
        IPage<CheckModelSeriesList> checkModelSeriesListIPage =
                checkModelSeriesListService.querySuccessCheckModelSeriesList(page, checkModelSeriesList);
        List<CheckModelSeriesList> data = checkModelSeriesListIPage.getRecords();
        ModelServiceItemDTO modelServiceItemDTO;
        String[] itemArr = new String[] {"认证一致性核查","关键件一致性核查","OBD静态验证","标准符合性核查","扫码符合性检查"};
        for (CheckModelSeriesList checkModelSeries : data) {
            List<ModelServiceItemDTO> itemData = new ArrayList<>();
            for (String itemStr : itemArr) {
                modelServiceItemDTO = new ModelServiceItemDTO();
                switch (itemStr){
                    case "认证一致性核查" :
                        modelServiceItemDTO.setCarOperator(itemStr);
                        modelServiceItemDTO.setOperationTime(checkModelSeries.getRealVehicleTime());
                        modelServiceItemDTO.setOperationUser(checkModelSeries.getRealMouldOperator());
                        modelServiceItemDTO.setType(checkModelSeries.getRealMouldStatus());
                        modelServiceItemDTO.setRemark(checkModelSeries.getCarRemarks());
                        break;
                    case "关键件一致性核查" :
                        modelServiceItemDTO = new ModelServiceItemDTO();
                        modelServiceItemDTO.setCarOperator(itemStr);
                        modelServiceItemDTO.setOperationTime(checkModelSeries.getKeyTime());
                        modelServiceItemDTO.setOperationUser(checkModelSeries.getKeyOperator());
                        modelServiceItemDTO.setType(checkModelSeries.getKeyStatus());
                        modelServiceItemDTO.setRemark(checkModelSeries.getKeyRemark());
                        break;
                    case "OBD静态验证" :
                        modelServiceItemDTO = new ModelServiceItemDTO();
                        modelServiceItemDTO.setCarOperator(itemStr);
                        modelServiceItemDTO.setOperationTime(checkModelSeries.getObdTime());
                        modelServiceItemDTO.setOperationUser(checkModelSeries.getObdOperator());
                        modelServiceItemDTO.setType(checkModelSeries.getObdStatus());
                        modelServiceItemDTO.setRemark(checkModelSeries.getObdRemark());
                        break;
                    case "扫码符合性检查" :
                        modelServiceItemDTO = new ModelServiceItemDTO();
                        modelServiceItemDTO.setCarOperator(itemStr);
                        modelServiceItemDTO.setOperationTime(checkModelSeries.getScanCodeTime());
                        modelServiceItemDTO.setOperationUser(checkModelSeries.getScanCodeOperator());
                        modelServiceItemDTO.setType(checkModelSeries.getScanCodeStatus());
                        modelServiceItemDTO.setRemark(checkModelSeries.getScanCodeRemark());
                        break;
                    case "标准符合性核查" :
                        modelServiceItemDTO = new ModelServiceItemDTO();
                        modelServiceItemDTO.setCarOperator(itemStr);
                        modelServiceItemDTO.setOperationTime(checkModelSeries.getStandTime());
                        modelServiceItemDTO.setOperationUser(checkModelSeries.getStandOperator());
                        modelServiceItemDTO.setType(checkModelSeries.getStandStatus());
                        modelServiceItemDTO.setRemark(checkModelSeries.getStandRemark());
                        break;
                    default:
                        break;
                }
                itemData.add(modelServiceItemDTO);
            }
            checkModelSeries.setArr(itemData);
        }
        checkModelSeriesListIPage.setRecords(data);
        return Result.success("200", "车型系列表分页查询", checkModelSeriesListIPage);
    }

    /**
     * 车型系列表复核分页查询
     *
     * @param checkModelSeriesList
     * @return
     */
    @ApiOperation(value = "|queryCheckModelSeriesListByPage|车型系列表复核分页查询")
    @GetMapping(value = "/queryReviewCheckModelSeriesList")
    public ResponseMessage queryReviewCheckModelSeriesList(CheckModelSeriesList checkModelSeriesList) {
        checkModelSeriesList.setBase(UserUtil.getQyId());
        Page page = new Page(checkModelSeriesList.getPage(), checkModelSeriesList.getPageSize());
        if (StringUtils.isNotEmpty(checkModelSeriesList.getVehicleType())) {
            checkModelSeriesList.setVehicleType(checkModelSeriesList.getVehicleType().toUpperCase());
        }
        IPage<CheckModelSeriesList> checkModelSeriesListIPage =
                checkModelSeriesListService.queryReviewCheckModelSeriesList(page, checkModelSeriesList);
        List<CheckModelSeriesList> data = checkModelSeriesListIPage.getRecords();
        ModelServiceItemDTO modelServiceItemDTO;
        String[] itemArr = new String[] {"认证一致性核查","关键件一致性核查","OBD静态验证","标准符合性核查","扫码符合性检查"};
        for (CheckModelSeriesList checkModelSeries : data) {
            List<ModelServiceItemDTO> itemData = new ArrayList<>();
            for (String itemStr : itemArr) {
                modelServiceItemDTO = new ModelServiceItemDTO();
                switch (itemStr){
                    case "认证一致性核查" :
                        modelServiceItemDTO.setCarOperator(itemStr);
                        modelServiceItemDTO.setOperationTime(checkModelSeries.getRealVehicleTime());
                        modelServiceItemDTO.setOperationUser(checkModelSeries.getRealMouldOperator());
                        modelServiceItemDTO.setType(checkModelSeries.getRealMouldStatus());
                        modelServiceItemDTO.setRemark(checkModelSeries.getCarRemarks());
                        break;
                    case "关键件一致性核查" :
                        modelServiceItemDTO = new ModelServiceItemDTO();
                        modelServiceItemDTO.setCarOperator(itemStr);
                        modelServiceItemDTO.setOperationTime(checkModelSeries.getKeyTime());
                        modelServiceItemDTO.setOperationUser(checkModelSeries.getKeyOperator());
                        modelServiceItemDTO.setType(checkModelSeries.getKeyStatus());
                        modelServiceItemDTO.setRemark(checkModelSeries.getKeyRemark());
                        break;
                    case "OBD静态验证" :
                        modelServiceItemDTO = new ModelServiceItemDTO();
                        modelServiceItemDTO.setCarOperator(itemStr);
                        modelServiceItemDTO.setOperationTime(checkModelSeries.getObdTime());
                        modelServiceItemDTO.setOperationUser(checkModelSeries.getObdOperator());
                        modelServiceItemDTO.setType(checkModelSeries.getObdStatus());
                        modelServiceItemDTO.setRemark(checkModelSeries.getObdRemark());
                        break;
                    case "扫码符合性检查" :
                        modelServiceItemDTO = new ModelServiceItemDTO();
                        modelServiceItemDTO.setCarOperator(itemStr);
                        modelServiceItemDTO.setOperationTime(checkModelSeries.getScanCodeTime());
                        modelServiceItemDTO.setOperationUser(checkModelSeries.getScanCodeOperator());
                        modelServiceItemDTO.setType(checkModelSeries.getScanCodeStatus());
                        modelServiceItemDTO.setRemark(checkModelSeries.getScanCodeRemark());
                        break;
                    case "标准符合性核查" :
                        modelServiceItemDTO = new ModelServiceItemDTO();
                        modelServiceItemDTO.setCarOperator(itemStr);
                        modelServiceItemDTO.setOperationTime(checkModelSeries.getStandTime());
                        modelServiceItemDTO.setOperationUser(checkModelSeries.getStandOperator());
                        modelServiceItemDTO.setType(checkModelSeries.getStandStatus());
                        modelServiceItemDTO.setRemark(checkModelSeries.getStandRemark());
                        break;
                    default:
                        break;
                }
                itemData.add(modelServiceItemDTO);
            }
            checkModelSeries.setArr(itemData);
        }
        checkModelSeriesListIPage.setRecords(data);
        return Result.success("200", "车型系列表分页查询", checkModelSeriesListIPage);
    }

    @ApiOperation(value = "|offlineCaching|离线缓存")
    @GetMapping(value = "offlineCaching")
    public ResponseMessage offlineCaching(CheckModelSeriesList checkModelSeriesList) {
        List<CheckModelSeriesList> list = checkModelSeriesListService.queryCheckModelSeriesList(checkModelSeriesList);
        return Result.success("200", "缓存成功", list);
    }

//    @ApiOperation(value = "|offlineCaching|离线缓存")
//    @GetMapping(value = "offlineCaching1")
//    public ResponseMessage offlineCaching1(CheckModelSeriesList checkModelSeriesList) {
//        List<CheckModelSeriesList> list = checkModelSeriesListService.queryCheckModelSeriesListFh(checkModelSeriesList);
//        return Result.success("200", "缓存成功", list);
//    }
//
//    @ApiOperation(value = "|synchronize|同步数据")
//    @PostMapping(value = "synchronize")
//    public ResponseMessage synchronize(@RequestBody CheckModelSeriesListDTO checkModelSeriesListDTO) {
//        for (CheckModelSeriesList data: checkModelSeriesListDTO.getList()){
//            data.setCreateTime(new Date());
//        }
//        checkModelSeriesListService.updateBatchById(checkModelSeriesListDTO.getList());
//        for (CheckModelSeriesList data : checkModelSeriesListDTO.getList()) {
//            for (CheckVehicleCheckMenu data1 : data.getCheckVehicleCheckMenuList()) {
//                if (data1.getParameterCheckState() != null) {
//                    List<String> idList = Arrays.asList(data1.getId().split(","));
//                    UpdateWrapper updateWrapper = new UpdateWrapper();
//                    updateWrapper.set("PARAMETER_CHECK_STATE", data1.getParameterCheckState());
//                    updateWrapper.in("ID", idList);
//                    checkVehicleCheckMenuService.update(updateWrapper);
//                }
//                if (!data1.getCheckRealVehicleVerificationList().isEmpty()) {
//                    synchronize1(data1);
//                }
//            }
//            CheckModelSeriesList checkModelSeriesList = new CheckModelSeriesList();
//            checkModelSeriesList.setId(data.getId());
//            checkModelSeriesList.setRealVehicleIsCheck(1);
//            checkModelSeriesList.setVehicleType(data.getVehicleTypeAndGroup());
//            checkModelSeriesList.setCarOperator(data.getCarOperator());
//            checkModelSeriesList.setEditionCode(data.getEditionCode());
//            checkModelSeriesList.setBase(data.getBase());
//            if (checkModelSeriesListDTO.getType() != null && checkModelSeriesListDTO.getType() == 0) {
//                updateByIsChecks(checkModelSeriesList);
//            }
//        }
//        return Result.success("200", "同步成功", null);
//    }

    private void synchronize1(CheckVehicleCheckMenu data1){
        List<CheckRealVehicleVerification> list = data1.getCheckRealVehicleVerificationList();
        int i = 0;
        for (; i < list.size(); i++) {
            if (!list.get(i).getType().equals("0")) {
                if (list.get(i).getCheckPicturePath() == null) {
                    list.get(i).setCheckPicturePath("");
                }
                if (list.get(i).getCheckPicturePathTwo() == null) {
                    list.get(i).setCheckPicturePathTwo("");
                }
            } else {
                list.remove(i);
                i--;
            }
        }
        if (!list.isEmpty()) {
            checkRealVehicleVerificationService.updateBatchById(list);
        }
    }


    /**
     * 车型系列表分页查询（复核）
     *
     * @param checkModelSeriesList
     * @return
     */
    @ApiOperation(value = "|queryCheckModelSeriesListByPageFh|车型系列表分页查询（复核）")
    @GetMapping(value = "/queryCheckModelSeriesListByPageFh")
    public ResponseMessage queryCheckModelSeriesListByPageFh(CheckModelSeriesList checkModelSeriesList) {
        Page page = new Page(checkModelSeriesList.getPage(), checkModelSeriesList.getPageSize());
        if (StringUtils.isNotEmpty(checkModelSeriesList.getVehicleType())) {
            checkModelSeriesList.setVehicleType(checkModelSeriesList.getVehicleType().toUpperCase());
        }
        IPage<CheckModelSeriesList> checkModelSeriesListIPage =
                checkModelSeriesListService.queryCheckModelSeriesListByPageFh(page, checkModelSeriesList);
        return Result.success("200", "车型系列表分页查询（复核）", checkModelSeriesListIPage);
    }

    /**
     * 车型系列表结果分页查询
     *
     * @param checkModelSeriesList
     * @return
     */
    @ApiOperation(value = "|queryCheckedModelSeriesListByPage|车型系列表结果分页查询")
    @GetMapping(value = "/queryCheckedModelSeriesListByPage")
    public ResponseMessage queryCheckedModelSeriesListByPage(CheckModelSeriesList checkModelSeriesList) {
        if (StringUtils.isNotEmpty(checkModelSeriesList.getVehicleType())) {
            checkModelSeriesList.setVehicleType(checkModelSeriesList.getVehicleType().toUpperCase());
        }
        Page page = new Page(checkModelSeriesList.getPage(), checkModelSeriesList.getPageSize());
        IPage<CheckModelSeriesList> checkModelSeriesListIPage
                = checkModelSeriesListService.queryCheckedModelSeriesListByPage(page, checkModelSeriesList);
        return Result.success("200", "车型系列表结果分页查询", checkModelSeriesListIPage);
    }

    /**
     * 车型库（查看）查询
     *
     * @return
     */
//    @ApiOperation(value = "|queryCheckModelSeriesListDedails|车型库（查看）查询")
//    @GetMapping(value = "/queryCheckModelSeriesListDedails")
//    public ResponseMessage queryCheckModelSeriesListDedails(String vehicleModel,
//                                                            String vehicleGroup,
//                                                            String editionCode,
//                                                            String base) {
//        List<CheckEnterpriseDataDetails> list = checkEnterpriseDataDetailsService.queryCheckModelSeriesListDedails(vehicleModel, vehicleGroup, editionCode, base);
//        return Result.success("200", "车型库（查看）查询", list);
//    }

    /**
     * 新增车型系列表数据
     *
     * @param checkModelSeriesList
     * @return
     */
    @ApiOperation(value = "|addCheckModelSeriesList|新增车型系列表数据")
    @PostMapping(value = "/addCheckModelSeriesList")
    public ResponseMessage addCheckModelSeriesList(@RequestBody CheckModelSeriesList checkModelSeriesList) {
        checkModelSeriesList.setBase(UserUtil.getQyId());
        List<String> baseIdList = Arrays.asList(checkModelSeriesList.getBase().split(","));
        List<String> list2 = baseIdList.stream().distinct().collect(Collectors.toList());
        if (list2.size() > 1) {
            return Result.error("-1", "请选择同一生产地址车型创建车型系列");
        }
        QueryWrapper queryWrapper = new QueryWrapper();
        queryWrapper.eq("VEHICLE_SERIES", checkModelSeriesList.getVehicleSeries());
        queryWrapper.eq("BASE", checkModelSeriesList.getBase());
        queryWrapper.eq("EDITION_CODE","1");
        if (checkModelSeriesListService.getOne(queryWrapper) != null) {
            return Result.error("-2", "车型系列名称已存在");
        }
//        QueryWrapper queryWrapper1 = new QueryWrapper();
//        queryWrapper1.eq("VEHICLE_TYPE_AND_GROUP", checkModelSeriesList.getVehicleTypeAndGroup());
//        queryWrapper1.eq("BASE", list2.get(0));
//        queryWrapper1.eq("EDITION_CODE", checkModelSeriesList.getEditionCode());
//        if (checkModelSeriesListService.getOne(queryWrapper1) != null) {
//            return Result.error("-1", "所选车型已创建/Vehicle type series  has been created for the selected vehicle type");
//        }
        checkModelSeriesList.setRealVehicleIsCheck(0);
        checkModelSeriesList.setType(0);
        checkModelSeriesList.setBase(list2.get(0));
        checkModelSeriesListService.addCheckModelSeriesList(checkModelSeriesList);
//        if (flag) {
//            iCheckOperationLogService.operationLog(
//                    request.getHeader("userId"),
//                    "新增车型系列表数据");
//            return Result.success("200", "操作成功", null);
//        }
        return Result.success("200", "操作成功", null);
    }

    /**
     * 新增车型系列表数据
     *
     * @param checkModelSeriesList
     * @return
     */
    @ApiOperation(value = "|validSeriesName|新增车型系列表数据重复验证")
    @PostMapping(value = "/validSeriesName")
    public ResponseMessage validSeriesName(@RequestBody CheckModelSeriesList checkModelSeriesList) {
        QueryWrapper queryWrapper = new QueryWrapper();
        queryWrapper.eq("VEHICLE_SERIES", checkModelSeriesList.getVehicleSeries());
        queryWrapper.eq("BASE",checkModelSeriesList.getBase());
        if (checkModelSeriesListService.getOne(queryWrapper) != null) {
            return Result.error("-1", "车型系列已存在");
        }
        return Result.error("200", "查询成功");
    }

    /**
     * 编辑车型系列表数据
     *
     * @param checkModelSeriesList
     * @return
     */
//    @ApiOperation(value = "|editCheckModelSeriesList|编辑车型系列表数据")
//    @PutMapping(value = "/editCheckModelSeriesList")
//    public ResponseMessage editCheckModelSeriesList(@RequestBody CheckModelSeriesList checkModelSeriesList) {
//        QueryWrapper queryWrapper = new QueryWrapper();
//        queryWrapper.eq("VEHICLE_SERIES", checkModelSeriesList.getVehicleSeries());
//        queryWrapper.ne("ID", checkModelSeriesList.getId());
//        if (checkModelSeriesListService.getOne(queryWrapper) != null) {
//            return Result.error("-1", "数据已存在/Data already exists");
//        }
//        if (checkModelSeriesListService.updateById(checkModelSeriesList)) {
//            iCheckOperationLogService.operationLog(
//                    request.getHeader("userId"),
//                    "编辑车型系列表数据");
//            return Result.success("200", "操作成功", true);
//        }
//        return Result.error("-1", "操作失败", false);
//    }

    /**
     * 删除车型系列表数据
     *
     * @param id
     * @return
     */
//    @ApiOperation(value = "|deleteCheckModelSeriesList|删除车型系列表数据")
//    @DeleteMapping(value = "/deleteCheckModelSeriesList")
//    public ResponseMessage deleteCheckModelSeriesList(String id, String vehicleType) {
//        List<String> list = Arrays.asList(vehicleType.split(","));
//        if (checkModelSeriesListService.removeById(id)) {
//            QueryWrapper queryWrapper = new QueryWrapper();
//            queryWrapper.eq("VEHICLE_SERIES_ID", id);
//            checkVehicleAndSeriesService.remove(queryWrapper);
//            for (String data : list) {
//                UpdateWrapper updateWrapper = new UpdateWrapper();
//                updateWrapper.set("TYPE", 0);
//                updateWrapper.eq("VEHICLE_TYPE", data);
//                checkEnterpriseDataService.update(updateWrapper);
//                UpdateWrapper updateWrapper1 = new UpdateWrapper();
//                updateWrapper1.set("TYPE", 0);
//                updateWrapper1.in("VEHICLE_MODEL", data);
//                cdVehiclesService.update(updateWrapper1);
//            }
//            iCheckOperationLogService.operationLog(
//                    request.getHeader("userId"),
//                    "删除车型系列表数据");
//            return Result.success("200", "操作成功", true);
//        }
//        return Result.error("-1", "操作失败", false);
//    }

    /**
     * 实车核查完成更新状态
     *
     * @param checkModelSeriesList
     * @return
     */
//    @ApiOperation(value = "|updateByIsCheck|实车核查完成更新状态")
//    @PostMapping("")
//    public ResponseMessage updateByIsCheck(@RequestBody CheckModelSeriesList checkModelSeriesList) {
//        if (updateByIsChecks(checkModelSeriesList)) {
//            return Result.success("200", "操作成功", null);
//        }
//        return Result.error("-1", "操作失败");
//    }

//    private Boolean updateByIsChecks(CheckModelSeriesList checkModelSeriesList) {
//        checkModelSeriesList.setRealVehicleTime(new Date());
//        if (checkModelSeriesListService.updateById(checkModelSeriesList)) {
//            QueryWrapper queryWrapper = new QueryWrapper();
//            queryWrapper.eq("VEHICLE_SERIES_ID", checkModelSeriesList.getId());
//            List<CheckVehicleCheckMenu> listMenu = checkVehicleCheckMenuService.getMenuByVId(checkModelSeriesList.getId());
//            List<CheckRealVehicleVerification> listInfo = checkRealVehicleVerificationService.list(queryWrapper);
//            for (CheckVehicleCheckMenu data : listMenu) {
//                updateByIsChecks1(data, checkModelSeriesList, listInfo);
//            }
//            /**
//             * 记录核查完成的数据
//             */
//            String id = UUIDUtils.getUUID();
//            List<CheckRealVehicleVerification> lists = checkRealVehicleVerificationService.list(queryWrapper);
//            List<CheckRealVehicleVerResult> list1 = new ArrayList<>();
//            for (CheckRealVehicleVerification data1 : lists) {
//                CheckRealVehicleVerResult checkRealVehicleVerResult = new CheckRealVehicleVerResult();
//                checkRealVehicleVerResult.setId(UUIDUtils.getUUID());
//                checkRealVehicleVerResult.setParameterName(data1.getParameterName());
//                checkRealVehicleVerResult.setVehicleType(data1.getVehicleType());
//                checkRealVehicleVerResult.setParamConfig(data1.getParamConfig());
//                checkRealVehicleVerResult.setStandardPicturePath(data1.getStandardPicturePath());
//                checkRealVehicleVerResult.setType(data1.getType());
//                checkRealVehicleVerResult.setCheckPicturePath(data1.getCheckPicturePath());
//                checkRealVehicleVerResult.setCheckPicturePathTwo(data1.getCheckPicturePathTwo());
//                checkRealVehicleVerResult.setRemarks(data1.getRemarks());
//                checkRealVehicleVerResult.setVehicleSeriesId(id);
//                checkRealVehicleVerResult.setHandleType(Integer.valueOf(data1.getHandleType()));
//                checkRealVehicleVerResult.setOldId(data1.getId());
//                checkRealVehicleVerResult.setParameter(data1.getParameter());
//                list1.add(checkRealVehicleVerResult);
//            }
//            checkRealVehicleVerResultService.saveBatch(list1);
//            CheckModelSeriesList data = checkModelSeriesListService.getById(checkModelSeriesList.getId());
//            CheckModelSeriesListResult checkModelSeriesListResult = new CheckModelSeriesListResult();
//            checkModelSeriesListResult.setId(id);
//            checkModelSeriesListResult.setVehicleSeries(data.getVehicleSeries());
//            checkModelSeriesListResult.setVehicleTypeAndGroup(data.getVehicleTypeAndGroup());
//            checkModelSeriesListResult.setRealVehicleTime(data.getRealVehicleTime());
//            checkModelSeriesListResult.setBase(data.getBase());
//            checkModelSeriesListResult.setCarOperator(data.getCarOperator());
//            List<String> type = lists
//                    .stream()
//                    .map(CheckRealVehicleVerification::getType)
//                    .collect(Collectors.toList());
//            if (type.contains("0")) {
//                checkModelSeriesListResult.setType(1);
//                // 包含不一致项则显示不一致（不包含待确认）
//            } else {
//                checkModelSeriesListResult.setType(0);
//            }
//            if (data.getStoProduction() != null) {
//                checkModelSeriesListResult.setStoproduction(data.getStoProduction());
//            } else if (type.contains("3")) {
//                checkModelSeriesListResult.setStoproduction(2);
//            } else {
//                checkModelSeriesListResult.setStoproduction(0);
//            }
//            checkModelSeriesListResult.setCarRemarks(data.getCarRemarks());
//            checkModelSeriesListResult.setRealVehicleIsCheck(1);
//            checkModelSeriesListResultService.save(checkModelSeriesListResult);
//            List<CheckStatute> list3 = new ArrayList<>();
//            for (CheckRealVehicleVerification aa : lists) {
//                if (aa.getType().equals("3")) {
//                    CheckStatute checkStatute = new CheckStatute();
//                    checkStatute.setId(UUIDUtils.getUUID());
//                    checkStatute.setProject(aa.getParameterName());
//                    checkStatute.setIncludedModels(aa.getVehicleType());
//                    checkStatute.setConfigParameter(aa.getParamConfig());
//                    checkStatute.setStandardPicture(aa.getStandardPicturePath());
//                    checkStatute.setRemarks(aa.getRemarks());
//                    checkStatute.setCompletionTime(data.getRealVehicleTime());
//                    checkStatute.setBase(data.getBase());
//                    checkStatute.setIsHandel(0);
//                    checkStatute.setVehicleSeries(data.getVehicleSeries());
//                    list3.add(checkStatute);
//                }
//            }
//            return checkStatuteService.saveBatch(list3);
//        }
//        return false;
//    }

    private void updateByIsChecks1(CheckVehicleCheckMenu data, CheckModelSeriesList checkModelSeriesList, List<CheckRealVehicleVerification> listInfo) {
        CheckRealVehicleVerificationDto checkRealVehicleVerificationDto = new CheckRealVehicleVerificationDto();
        checkRealVehicleVerificationDto.setParameterName(data.getParameterName());
        checkRealVehicleVerificationDto.setParameterData(data.getParameterData());
        checkRealVehicleVerificationDto.setParameterType(data.getParameterType());
        checkRealVehicleVerificationDto.setParameterCodeOne(data.getParameterCodeOne());
        checkRealVehicleVerificationDto.setParameterCodeTwo(data.getParameterCodeTwo());
        checkRealVehicleVerificationDto.setVehicleType(checkModelSeriesList.getVehicleType());
        checkRealVehicleVerificationDto.setVehicleSeriesId(checkModelSeriesList.getId());
        checkRealVehicleVerificationDto.setEditionCode(checkModelSeriesList.getEditionCode());
        checkRealVehicleVerificationDto.setBase(checkModelSeriesList.getBase());
        boolean flag = true;
        for (CheckRealVehicleVerification data1 : listInfo) {
            if (checkRealVehicleVerificationDto.getParameterType().equals("3")) {
                if (data1.getParameter() != null && data1.getParameter().equals(checkRealVehicleVerificationDto.getParameterCodeOne())) {
                    flag = false;
                    break;
                }
            } else {
                if (data1.getId().contains("_" + checkRealVehicleVerificationDto.getParameterType())
                        && (data1.getParameterName().equals(checkRealVehicleVerificationDto.getParameterName())
                        || data1.getParameterName().equals(checkRealVehicleVerificationDto.getParameterName() + " 1"))) {
                    flag = false;
                    break;
                }
            }

        }
        if (flag) {
            checkRealVehicleVerificationService.saveInfo(checkRealVehicleVerificationDto);
        }
    }

    /**
     * 关键件核查完成更新状态
     *
     * @param checkModelSeriesList
     * @return
     */
    @ApiOperation(value = "|updateByIsCheckKey|关键件核查完成更新状态")
    @PostMapping("/updateByIsCheckKey")
    public ResponseMessage updateByIsCheckKey(@RequestBody CheckModelSeriesList checkModelSeriesList) {
        UpdateWrapper updateWrapper = new UpdateWrapper();
        updateWrapper.eq("ID", checkModelSeriesList.getId());
        if (checkModelSeriesListService.update(updateWrapper)) {
            return Result.success("200", "操作成功", null);
        }
        return Result.error("-1", "操作失败");
    }

    /**
     * 首页统计
     *
     * @param checkModelSeriesList
     * @return
     */
    @ApiOperation(value = "|stat|首页统计")
    @PostMapping(value = "/stat")
    public ResponseMessage stat(@RequestBody CheckModelSeriesList checkModelSeriesList) {
        Map<String, Integer> map = checkModelSeriesListService.stat(checkModelSeriesList);
        return Result.success("200", "车型系列表详情查询", map);
    }


    /**
     * 更新备注
     */
    @ApiOperation(value = "|updateRemarks|更新备注")
    @PostMapping(value = "/updateRemarks")
    public ResponseMessage updateRemarks(@RequestBody CheckModelSeriesList checkModelSeriesList) {
        checkModelSeriesList.setCreateTime(new Date());
        if (checkModelSeriesListService.updateById(checkModelSeriesList)) {
            return Result.success("200", "操作成功", null);
        }
        return Result.error("-1", "操作失败");
    }

    /**
     * 已停产
     */
//    @ApiOperation(value = "|stoProduction|已停产")
//    @PostMapping(value = "/stoProduction")
//    public ResponseMessage stoProduction(@RequestBody CheckModelSeriesList checkModelSeriesList) {
//        List<String> idList = Arrays.asList(checkModelSeriesList.getId().split(","));
//        UpdateWrapper updateWrapper = new UpdateWrapper();
//        updateWrapper.set("STOPRODUCTION", 1);
//        updateWrapper.set("REAL_VEHICLE_TIME", new Date());
//        updateWrapper.set("REAL_VEHICLE_IS_CHECK", 1);
//        updateWrapper.in("ID", idList);
//        if (checkModelSeriesListService.update(updateWrapper)) {
//            /**
//             * 记录核查完成的数据
//             */
//            for (String vehicleSeriesId : idList) {
//                QueryWrapper queryWrapper = new QueryWrapper();
//                queryWrapper.eq("VEHICLE_SERIES_ID", vehicleSeriesId);
//                String id = UUIDUtils.getUUID();
//                List<CheckRealVehicleVerification> lists = checkRealVehicleVerificationService.list(queryWrapper);
//                List<CheckRealVehicleVerResult> list1 = new ArrayList<>();
//                for (CheckRealVehicleVerification data1 : lists) {
//                    CheckRealVehicleVerResult checkRealVehicleVerResult = new CheckRealVehicleVerResult();
//                    checkRealVehicleVerResult.setId(UUIDUtils.getUUID());
//                    checkRealVehicleVerResult.setParameterName(data1.getParameterName());
//                    checkRealVehicleVerResult.setVehicleType(data1.getVehicleType());
//                    checkRealVehicleVerResult.setParamConfig(data1.getParamConfig());
//                    checkRealVehicleVerResult.setStandardPicturePath(data1.getStandardPicturePath());
//                    checkRealVehicleVerResult.setType(data1.getType());
//                    checkRealVehicleVerResult.setCheckPicturePath(data1.getCheckPicturePath());
//                    checkRealVehicleVerResult.setRemarks(data1.getRemarks());
//                    checkRealVehicleVerResult.setVehicleSeriesId(id);
//                    checkRealVehicleVerResult.setHandleType(Integer.valueOf(data1.getHandleType()));
//                    checkRealVehicleVerResult.setOldId(data1.getId());
//                    checkRealVehicleVerResult.setParameter(data1.getParameter());
//                    list1.add(checkRealVehicleVerResult);
//                }
//                checkRealVehicleVerResultService.saveBatch(list1);
//                CheckModelSeriesList data = checkModelSeriesListService.getById(checkModelSeriesList.getId());
//                CheckModelSeriesListResult checkModelSeriesListResult = new CheckModelSeriesListResult();
//                checkModelSeriesListResult.setId(id);
//                checkModelSeriesListResult.setCreateTime(new Date());
//                checkModelSeriesListResult.setVehicleSeries(data.getVehicleSeries());
//                checkModelSeriesListResult.setVehicleTypeAndGroup(data.getVehicleTypeAndGroup());
//                checkModelSeriesListResult.setRealVehicleTime(data.getRealVehicleTime());
//                checkModelSeriesListResult.setBase(data.getBase());
//                checkModelSeriesListResult.setCarOperator(data.getCarOperator());
//                c1(lists, checkModelSeriesListResult, data);
//                List<CheckStatute> list3 = new ArrayList<>();
//                for (CheckRealVehicleVerification aa : lists) {
//                    if (aa.getType().equals("3")) {
//                        CheckStatute checkStatute = new CheckStatute();
//                        checkStatute.setId(UUIDUtils.getUUID());
//                        checkStatute.setVehicleSeries(data.getVehicleSeries());
//                        checkStatute.setProject(aa.getParameterName());
//                        checkStatute.setIncludedModels(aa.getVehicleType());
//                        checkStatute.setConfigParameter(aa.getParamConfig());
//                        checkStatute.setStandardPicture(aa.getStandardPicturePath());
//                        checkStatute.setRemarks(aa.getRemarks());
//                        checkStatute.setCompletionTime(data.getRealVehicleTime());
//                        checkStatute.setBase(data.getBase());
//                        checkStatute.setIsHandel(0);
//                        list3.add(checkStatute);
//                    }
//                }
//                checkStatuteService.saveBatch(list3);
//            }
//
//            return Result.success("200", "操作成功", null);
//        }
//        return Result.error("-1", "操作失败");
//    }

    private void c1(List<CheckRealVehicleVerification> lists, CheckModelSeriesListResult checkModelSeriesListResult, CheckModelSeriesList data) {
        List<String> type = lists
                .stream()
                .map(CheckRealVehicleVerification::getType)
                .collect(Collectors.toList());
        if (type.contains("0") && (type.contains("3") || type.contains("2") || type.contains("1") || type.contains("4"))) {
            checkModelSeriesListResult.setType(1);
            // 包含不一致项则显示不一致（不包含待确认）
        } else if (!type.contains("0") && type.contains("3")) {
            checkModelSeriesListResult.setType(2);
            // 包含一致项则显示一致（不包含待确认,不一致）
        } else if (!type.contains("0") && !type.contains("3") && type.contains("2")) {
            checkModelSeriesListResult.setType(3);
            // 包含核查期间未供货项则显示核查期间未供货（不包含待确认,不一致,一致）
        } else if (!type.contains("0") && !type.contains("3") && !type.contains("2") && type.contains("1")) {
            checkModelSeriesListResult.setType(4);
            // 包含停止供货项则显示停止供货（不包含待确认,不一致,一致,核查期间未供货）
        } else if (!type.contains("0") && !type.contains("3") && !type.contains("2") && !type.contains("1") && type.contains("4")) {
            checkModelSeriesListResult.setType(5);
        } else {
            // 待确认
            checkModelSeriesListResult.setType(0);
        }
        checkModelSeriesListResult.setStoproduction(data.getStoProduction());
        checkModelSeriesListResult.setCarRemarks(data.getCarRemarks());
        checkModelSeriesListResult.setRealVehicleIsCheck(1);
        checkModelSeriesListResultService.save(checkModelSeriesListResult);
    }
    /**
     * 非操作列核查完成
     */
    @ApiOperation(value = "|updateRemarks|非操作列核查完成")
    @GetMapping(value = "/checkOk")
    public ResponseMessage checkOk(String ids) {
        if (StringUtils.isBlank(ids)) {
            return Result.error("-1","参数缺失");
        }
        checkModelSeriesListService.checkOk(ids);
        return Result.success("200", "操作成功");
    }

    /**
     * 根据id删除车型系列
     */
    @ApiOperation(value = "根据id删除车型系列")
    @DeleteMapping(value = "/deleteModelById")
    public ResponseMessage deleteModelById(String ids) {
        if (StringUtils.isEmpty(ids)) {
            return Result.error("-1","参数缺失");
        }
        List<String> list = Arrays.asList(ids.split(","));
        checkModelSeriesListService.removeByIds(list);
        return Result.success("200", "操作成功",true);
    }
}
