package com.adc.da.system.controller;


import com.adc.da.system.entity.CheckModelSeriesListResult;
import com.adc.da.system.service.ICheckModelSeriesListResultService;
import com.adc.da.base.web.BaseController;
import com.adc.da.util.http.ResponseMessage;
import com.adc.da.util.http.Result;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

/**
 * <p>
 *  实车核查结果前端控制器
 * </p>
 *
 * @author jobob
 * @since 2020-03-05
 */
@RestController
@RequestMapping("/${restPath}/check-model-series-list-result")
public class CheckModelSeriesListResultController extends BaseController {

    @Autowired
    private ICheckModelSeriesListResultService checkModelSeriesListResultService;

    /**
     * 实车核查分页查询
     * @param checkModelSeriesListResult
     * @return
     */
    @GetMapping("/getByPage")
    public ResponseMessage getByPage(CheckModelSeriesListResult checkModelSeriesListResult){
        Page page = new Page(checkModelSeriesListResult.getPage(),checkModelSeriesListResult.getPageSize());
        if (checkModelSeriesListResult.getOrderBy() != null){
            switch (checkModelSeriesListResult.getOrderBy()){
                case "vehicleSeries":
                    checkModelSeriesListResult.setOrderBy("VEHICLE_SERIES");
                    break;
                case "vehicleTypeAndGroup":
                    checkModelSeriesListResult.setOrderBy("VEHICLE_TYPE_AND_GROUP");
                    break;
                case "realVehicleTime":
                    checkModelSeriesListResult.setOrderBy("REAL_VEHICLE_TIME");
                    break;
                case "orgName":
                    checkModelSeriesListResult.setOrderBy("NLSSORT(ORG_NAME,'NLS_SORT = SCHINESE_PINYIN_M')");
                    break;
                case "usName":
                    checkModelSeriesListResult.setOrderBy("NLSSORT(USNAME,'NLS_SORT = SCHINESE_PINYIN_M')");
                    break;
                case "realVehicleIsCheck":
                    checkModelSeriesListResult.setOrderBy("REAL_VEHICLE_IS_CHECK");
                    break;
                case "stoProduction":
                    checkModelSeriesListResult.setOrderBy("STOPRODUCTION");
                    break;
                case "carRemarks":
                    checkModelSeriesListResult.setOrderBy("NLSSORT(CAR_REMARKS,'NLS_SORT = SCHINESE_PINYIN_M')");
                    break;
                default:
                    break;
            }
        }
        IPage<CheckModelSeriesListResult> iPage = checkModelSeriesListResultService.getByPage(page,checkModelSeriesListResult);
        return Result.success("200", "实车核查结果分页查询",iPage);
    }
    /**
     * 实车核查list查询
     * @return
     */
    @GetMapping("/getModelList")
    public ResponseMessage getModelList(String base){
        List<String> baseIdList = new ArrayList<>();
        if (base != null){
            baseIdList = Arrays.asList(base.split(","));
        }
        List<CheckModelSeriesListResult> list = checkModelSeriesListResultService.getModelList(baseIdList);
        return Result.success("200", "实车核查结果list查询",list);
    }

    @PostMapping("appoint")
    public ResponseMessage appoint(@RequestBody CheckModelSeriesListResult checkModelSeriesListResult){
        if (checkModelSeriesListResultService.appoint(
                checkModelSeriesListResult.getId(),
                checkModelSeriesListResult.getVehicleSeriesId(),
                checkModelSeriesListResult.getVehicleType(),
                checkModelSeriesListResult.getCarOperator(),
                checkModelSeriesListResult.getEditionCode(),
                checkModelSeriesListResult.getBase())){
            return Result.success("200","操作成功",null);
        }
        return Result.success("200","没有可引用结果/No results to referenceNo results to reference");
    }


}
