package com.adc.da.system.controller;


import com.adc.da.system.entity.CheckRealVehicleVerResult;
import com.adc.da.system.service.ICheckRealVehicleVerResultService;
import com.adc.da.base.web.BaseController;

import com.adc.da.util.http.ResponseMessage;
import com.adc.da.util.http.Result;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

/**
 * <p>
 *  实车核查结果详情前端控制器
 * </p>
 *
 * @author jobob
 * @since 2020-03-05
 */
@RestController
@RequestMapping("/${restPath}/check-real-vehicle-ver-result")
public class CheckRealVehicleVerResultController extends BaseController {

    @Autowired
    private ICheckRealVehicleVerResultService checkRealVehicleVerResultService;

    /**
     * 日志service
     */
//    @Autowired
//    private ICheckOperationLogService iCheckOperationLogService;


    @Value("${uploadFile}")
    private String uploadFile;

    @GetMapping("/getByPage")
    public ResponseMessage getByPage(CheckRealVehicleVerResult checkRealVehicleVerResult){
        Page page = new Page(checkRealVehicleVerResult.getPage(),checkRealVehicleVerResult.getPageSize());
        QueryWrapper queryWrapper = new QueryWrapper();
        queryWrapper.eq("VEHICLE_SERIES_ID",checkRealVehicleVerResult.getVehicleSeriesId());
        if (checkRealVehicleVerResult.getParameterName() != null){
            queryWrapper.like("PARAMETER_NAME",checkRealVehicleVerResult.getParameterName());
        }
        if (checkRealVehicleVerResult.getOrderBy() != null){
            switch (checkRealVehicleVerResult.getOrderBy()){
                case "parameterName":
                    checkRealVehicleVerResult.setOrderBy("NLSSORT(PARAMETER_NAME,'NLS_SORT = SCHINESE_PINYIN_M')");
                    break;
                case "vehicleType":
                    checkRealVehicleVerResult.setOrderBy("VEHICLE_TYPE");
                    break;
                case "paramConfig":
                    checkRealVehicleVerResult.setOrderBy("NLSSORT(PARAM_CONFIG,'NLS_SORT = SCHINESE_PINYIN_M')");
                    break;
                case "type":
                    checkRealVehicleVerResult.setOrderBy("TYPE");
                    break;
                case "remarks":
                    checkRealVehicleVerResult.setOrderBy("NLSSORT(REMARKS,'NLS_SORT = SCHINESE_PINYIN_M')");
                    break;
                default:
                    break;
            }
            if (checkRealVehicleVerResult.getOrder().equals("asc")){
                queryWrapper.orderByAsc(checkRealVehicleVerResult.getOrderBy());
            }else {
                queryWrapper.orderByDesc(checkRealVehicleVerResult.getOrderBy());
            }
        }else {
            queryWrapper.orderByDesc("TYPE","PARAMETER_NAME");
        }
        return Result.success("200","实车核查详情分页查询",checkRealVehicleVerResultService.page(page,queryWrapper));
    }


    /**
     * 动力核查结果详情导出
     *
     * @param response
     */
//    @GetMapping(value = "/downDetails")
//    public void downDetails(HttpServletResponse response,
//                            HttpServletRequest request,
//                            String id,
//                            String vehicleSeriesId,
//                            String parameterName) {
//        OutputStream os = null;
//        Workbook workbook;
//        try {
//            response.setHeader(
//                    "Content-Disposition",
//                    "attachment; filename=" + ReadExcel.encodeFileName("实车核查结果详情" + ".xlsx", request));
//            response.setContentType("application/force-download");
//            ExportParams exportParams = new ExportParams();
//            exportParams.setType(ExcelType.XSSF);
//            QueryWrapper queryWrapper = new QueryWrapper();
//            if (id != null){
//                List<String> idList = Arrays.asList(id.split(","));
//                queryWrapper.in("ID",idList);
//            }else {
//                queryWrapper.like(parameterName != null,"PARAMETER_NAME",parameterName);
//                queryWrapper.eq("VEHICLE_SERIES_ID",vehicleSeriesId);
//            }
//            List<CheckRealVehicleVerResult> list = checkRealVehicleVerResultService.list(queryWrapper);
//            for (CheckRealVehicleVerResult data:list) {
//                if (data.getType() !=null){
//                    switch (data.getType()) {
//                        case "1":
//                            data.setTypeCh("核查期间未供货");
//                            break;
//                        case "2":
//                            data.setTypeCh("一致");
//                            break;
//                        case "3":
//                            data.setTypeCh("不一致");
//                            break;
//                        case "4":
//                            data.setTypeCh("停止供货");
//                            break;
//                        default:
//                            data.setTypeCh("待确认");
//                    }
//                }
//                if (data.getCheckPicturePath() != null){
//                    data.setCheckPictureUrl(FileUtil.readFileByBytes(uploadFile+data.getCheckPicturePath()));
//                }
//                if (data.getCheckPicturePathTwo() != null){
//                    data.setCheckPictureTwoUrl(FileUtil.readFileByBytes(uploadFile+data.getCheckPicturePathTwo()));
//                }
//            }
//            iCheckOperationLogService.operationLog(
//                    request.getHeader("userId"),
//                    "导出实车核查结果详情");
//            workbook = ExcelExportUtil.exportExcel(exportParams, CheckRealVehicleVerResult.class, list);
//            os = response.getOutputStream();
//            workbook.write(os);
//            os.flush();
//        } catch (Exception e) {
//            throw new AdcDaBaseException("下载文件失败，请重试");
//        } finally {
//            IOUtils.closeQuietly(os);
//        }
//    }
}
