package com.adc.da.system.controller;


import com.adc.da.dto.reqDTO.CheckRealVehicleVerificationDto;
import com.adc.da.system.entity.CheckVehicleCheckMenu;
import com.adc.da.system.service.ICheckVehicleCheckMenuService;
import com.adc.da.util.http.ResponseMessage;
import com.adc.da.util.http.Result;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

/**
 * 实车核查关键参数列表
 */
@RestController
@Api(value = "实车核查关键参数列表")
@RequestMapping("/${restPath}/checkVehicleCheckMenu")
public class CheckVehicleCheckMenuController {
    /**
     * checkVehicleCheckMenuService
     */
    @Autowired
    private ICheckVehicleCheckMenuService checkVehicleCheckMenuService;

    /**
     * 实车核查关键参数列表分页查询
     */
    @ApiOperation(value = "|queryByPage|实车核查关键参数列表分页查询")
    @GetMapping("/queryByPage")
    public ResponseMessage queryAll(CheckVehicleCheckMenu checkVehicleCheckMenu,
                                    CheckRealVehicleVerificationDto checkRealVehicleVerificationDto, String isShow) {
        Page page = new Page(checkVehicleCheckMenu.getPage(),checkVehicleCheckMenu.getPageSize());
        checkVehicleCheckMenuService.queryAll(checkVehicleCheckMenu);
        IPage<CheckVehicleCheckMenu> list = checkVehicleCheckMenuService.queryVehicleCheckMenuByPage(page,
                checkVehicleCheckMenu, checkRealVehicleVerificationDto,isShow);
        return Result.success("200", "实车核查关键参数列表分页查询", list);
    }

    /**
     * 判断是否存在待核查项
     * @param checkVehicleCheckMenu
     * @return
     */
    @ApiOperation(value = "|queryByVehicleSeriesId|判断是否存在待核查项")
    @GetMapping("/queryByVehicleSeriesId")
    public ResponseMessage queryByVehicleSeriesId(CheckVehicleCheckMenu checkVehicleCheckMenu){
        if (checkVehicleCheckMenuService.queryByVehicleSeriesId(checkVehicleCheckMenu.getVehicleSeriesId()).size() != 0){
            return Result.error("-1","还有待核查项，确认核查完成？");
        }
        return Result.success();
    }
}
