package com.adc.da.system.controller;


import com.adc.da.system.entity.VehicleList;
import com.adc.da.system.service.ICheckEnterpriseDataService;
import com.adc.da.util.http.ResponseMessage;
import com.adc.da.util.http.Result;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

/**
 * 车型列表
 */
@RestController
@Api(value = "车型列表")
@RequestMapping("/${restPath}/vehicleList")
public class VehicleListController {

    /**
     * checkEnterpriseDataService
     */
    @Autowired
    private ICheckEnterpriseDataService checkEnterpriseDataService;

    /**
     * 车型列表分页查询
     * @param vehicleList
     * @return
     */
    @ApiOperation(value = "|queryVehicleListByPage|车型列表分页查询")
    @GetMapping(value = "/queryVehicleListByPage")
    public ResponseMessage queryVehcleListByPage(VehicleList vehicleList) {
        Page page = new Page(vehicleList.getPage(),vehicleList.getPageSize());
        if ( StringUtils.isNotEmpty(vehicleList.getVehicleModel())) {
            vehicleList.setVehicleModel(vehicleList.getVehicleModel().toUpperCase());
        }
        if ( StringUtils.isNotEmpty(vehicleList.getProductNo())) {
            vehicleList.setProductNo(vehicleList.getProductNo().toUpperCase());
        }
        IPage<VehicleList> checkVehicleListIPage = checkEnterpriseDataService.queryVehicleListByPage(page, vehicleList);
        return Result.success("200", "车型列表分页查询", checkVehicleListIPage);
    }

}
